#  Item Flags:
from functools import reduce

CONSUMABLE = 0x0001
WEAPON = 0x0002
ARMOR = 0x0004
HELMET = 0x0008
SHIELD = 0x0010
GLOVE = 0x0020
RING = 0x0040
GEM = 0x0080
SPECIAL = 0x0100
SCENARIO = 0x0200
CURSED = 0x0400
DUMMY = 0x0800
BLUE_CHEST = 0x1000
IRIS = 0x2000
VALUABLE = 0x4000

MAXIM = 0x010000
TIA =   0x020000
GUY =   0x040000
SELAN = 0x080000
DEKAR = 0x100000
LEXIS = 0x200000
ARTEA = 0x400000

ANY_CHARACTER = MAXIM | TIA | GUY | SELAN | DEKAR | LEXIS | ARTEA
DEFAULT_NAMES = 'Maxim', 'Selan', 'Guy', 'Artea', 'Tia', 'Dekar', 'Lexis'
CHARACTER_FLAGS = MAXIM, SELAN, GUY, ARTEA, TIA, DEKAR, LEXIS

CHARACTER_KEY_FLAGS = {
    "M": MAXIM,
    "T": TIA,
    "G": GUY,
    "S": SELAN,
    "D": DEKAR,
    "L": LEXIS,
    "A": ARTEA
}


def used_by(character_codes):
    return reduce(lambda x, y: x | y, (CHARACTER_KEY_FLAGS[s.upper()] for s in character_codes))


ITEM_TABLE = [
    ("Nothing", CONSUMABLE),
    ("Charred Newt", CONSUMABLE),
    ("Potion", CONSUMABLE),
    ("Hi-Potion", CONSUMABLE),
    ("Ex-Potion", CONSUMABLE),
    ("Magic Jar", CONSUMABLE),
    ("Hi-Magic", CONSUMABLE),
    ("Ex-Magic", CONSUMABLE),
    ("Regain", CONSUMABLE),
    ("Miracle", CONSUMABLE | VALUABLE),
    ("Antidote", CONSUMABLE),
    ("Awake", CONSUMABLE),
    ("Shriek", CONSUMABLE),
    ("Mystery Pin", CONSUMABLE),
    ("Power Gourd", CONSUMABLE),
    ("Mind Gourd", CONSUMABLE),
    ("Magic Guard", CONSUMABLE),
    ("Life Potion", CONSUMABLE | VALUABLE),
    ("Spell Potion", CONSUMABLE | VALUABLE),
    ("Power Potion", CONSUMABLE | VALUABLE),
    ("Speed Potion", CONSUMABLE | VALUABLE),
    ("Mind Potion", CONSUMABLE | VALUABLE),
    ("Brave", CONSUMABLE | VALUABLE),
    ("Pear Cider", CONSUMABLE),
    ("Sour Cider", CONSUMABLE),
    ("Lime Cider", CONSUMABLE),
    ("Plum Cider", CONSUMABLE),
    ("Apple Cider", CONSUMABLE),
    ("Sleep Ball", CONSUMABLE),
    ("Confuse Ball", CONSUMABLE),
    ("Freeze Ball", CONSUMABLE),
    ("Smoke Ball", CONSUMABLE),
    ("Ice Ball", CONSUMABLE),
    ("Fire Ball", CONSUMABLE),
    ("Terror Ball", CONSUMABLE),
    ("Ear Pick", CONSUMABLE),
    ("Boomerang", CONSUMABLE),
    ("Big Boomer", CONSUMABLE),
    ("Ex-Boomer", CONSUMABLE),
    ("Dragon Tooth", CONSUMABLE),
    ("Green Tea", CONSUMABLE),
    ("Escape", CONSUMABLE),
    ("Warp", CONSUMABLE),
    ("Dragon Egg", SPECIAL | SCENARIO),
    ("Curselifter", CONSUMABLE | VALUABLE),
    ("Providence", CONSUMABLE | SPECIAL),
    ("Secret Fruit", SPECIAL),
    ("Holy Fruit", SPECIAL),
    ("Breeze Fruit", SPECIAL),
    ("Charm Fruit", SPECIAL),
    ("Dark Fruit", SPECIAL),
    ("Earth Fruit", SPECIAL),
    ("Flame Fruit", SPECIAL),
    ("Magic Fruit", SPECIAL),
    ("Dual Blade", WEAPON | MAXIM),
    ("Frypan", WEAPON | TIA | SELAN),
    ("Knife", WEAPON | TIA | SELAN | ARTEA),
    ("Small Knife", WEAPON | ANY_CHARACTER),
    ("Rapier", WEAPON | MAXIM | SELAN | ARTEA),
    ("Battle Knife", WEAPON | ANY_CHARACTER),
    ("Dagger", WEAPON | used_by("MGDLA")),
    ("Insect Crush", WEAPON | MAXIM | GUY | DEKAR),
    ("Long Knife", WEAPON),
    ("Short Sword", WEAPON),
    ("Light Knife", WEAPON),
    ("Kukri", WEAPON),
    ("Gladius", WEAPON),
    ("Cold Rapier", WEAPON),
    ("Scmitar", WEAPON),
    ("Deadly Sword I (C)", WEAPON | CURSED),
    ("Deadly Sword I", WEAPON),
    ("SuhrCustom11", WEAPON),
    ("Bronze Sword", WEAPON),
    ("Fire Dagger", WEAPON),
    ("War Rapier", WEAPON),
    ("Long Sword", WEAPON),
    ("Berserk Blade (C)", WEAPON | CURSED),
    ("Berserk Blade", WEAPON),
    ("Multi Sword", WEAPON),
    ("Rockbreaker", WEAPON),
    ("Broadsword", WEAPON),
    ("Estok", WEAPON),
    ("Silvo Rapier", WEAPON),
    ("Burn Sword", WEAPON),
    ("Dekar Blade", WEAPON | VALUABLE),
    ("Crazy Blade", WEAPON),
    ("Deadly Sword II (C)", WEAPON | CURSED),
    ("Deadly Sword II", WEAPON),
    ("Luck Rapier (C)", WEAPON),
    ("Luck Rapier", WEAPON),
    ("Aqua Sword", WEAPON),
    ("Red Saber", WEAPON),
    ("Lucky Blade (C)", WEAPON | CURSED),
    ("Lucky Blade", WEAPON),
    ("Mist Rapier", WEAPON),
    ("Boom Sword", WEAPON),
    ("Freeze Sword", WEAPON),
    ("Silver Sword", WEAPON),
    ("Flying Blade", WEAPON),
    ("Super Sword", WEAPON),
    ("Buster Sword", WEAPON),
    ("Rune Raiper", WEAPON),
    ("Old Sword", WEAPON | VALUABLE),
    ("Lizard Blow", WEAPON | VALUABLE),
    ("Zirco Sword", WEAPON),
    ("Sizzle Sword", WEAPON | BLUE_CHEST),
    ("Blaze Sword", WEAPON | BLUE_CHEST),
    ("Myth Blade", WEAPON | VALUABLE),
    ("Gades Blade", WEAPON | VALUABLE | BLUE_CHEST),
    ("Sky Sword", WEAPON | BLUE_CHEST),
    ("Snow Sword", WEAPON | BLUE_CHEST),
    ("Fry Sword", WEAPON | BLUE_CHEST),
    ("Egg Sword", WEAPON),
    ("Franshiska", WEAPON),
    ("Thunder Axe", WEAPON),
    ("Hand Axe", WEAPON),
    ("Bronze Axe", WEAPON),
    ("Flying Axe", WEAPON),
    ("Rainy Axe", WEAPON),
    ("Great Axe", WEAPON),
    ("Zirco Axe", WEAPON),
    ("Mega Axe", WEAPON | BLUE_CHEST),
    ("Mace", WEAPON),
    ("Rod", WEAPON),
    ("Staff", WEAPON),
    ("Deadly Rod (C)", WEAPON | CURSED),
    ("Deadly Rod", WEAPON),
    ("Sleep Rod", WEAPON),
    ("Long Staff", WEAPON),
    ("Holy Staff", WEAPON),
    ("Morning Star", WEAPON),
    ("Pounder Rod", WEAPON),
    ("Crystal Wand", WEAPON),
    ("Silver Rod", WEAPON),
    ("Zirco Rod", WEAPON),
    ("Zirco Flail", WEAPON),
    ("Spark Staff", WEAPON | BLUE_CHEST),
    ("Whip", WEAPON),
    ("Wire", WEAPON),
    ("Chain", WEAPON),
    ("Aqua Whip", WEAPON),
    ("Cutter Whip", WEAPON),
    ("Royal Whip", WEAPON),
    ("Holy Whip", WEAPON),
    ("Zirco Whip", WEAPON),
    ("Air Whip", WEAPON | BLUE_CHEST),
    ("Fatal Pick (C)", WEAPON | VALUABLE),
    ("Fatal Pick", WEAPON | VALUABLE),
    ("Spear", WEAPON),
    ("Trident", WEAPON),
    ("Hallard", WEAPON),
    ("Heavy Lance", WEAPON),
    ("Water Spear", WEAPON | BLUE_CHEST),
    ("Dragon Spear", WEAPON | BLUE_CHEST),
    ("Vice Pliers", WEAPON),
    ("Coma Hit", WEAPON),
    ("Figgoru", WEAPON),
    ("Superdriver", WEAPON),
    ("Stun Gun", WEAPON),
    ("Battledriver", WEAPON),
    ("Launcher", WEAPON),
    ("Freeze Bow", WEAPON),
    ("Cursed Bow (C)", WEAPON | VALUABLE),
    ("Arty's Bow", WEAPON | VALUABLE),
    ("Apron", ARMOR),
    ("Dress", ARMOR),
    ("Cloth", ARMOR),
    ("Lab-coat", ARMOR),
    ("Hide Armor", ARMOR),
    ("Frock", ARMOR),
    ("Robe", ARMOR),
    ("Cloth Armor", ARMOR),
    ("Coat", ARMOR),
    ("Tough Hide", ARMOR),
    ("Light Dress", ARMOR),
    ("Light Armor", ARMOR),
    ("Camu Armor", ARMOR),
    ("Baggy", ARMOR),
    ("Tight Dress", ARMOR),
    ("Chainmail", ARMOR),
    ("Holy Wings", ARMOR | VALUABLE),
    ("Ironmail", ARMOR),
    ("Toga", ARMOR),
    ("Chain Armor", ARMOR),
    ("Thick Cloth", ARMOR),
    ("Stone Plate", ARMOR),
    ("Long Robe", ARMOR),
    ("Plated Cloth", ARMOR),
    ("Iron Plate", ARMOR),
    ("Metal Mail", ARMOR),
    ("Silk Toga", ARMOR),
    ("Silver Armor", ARMOR),
    ("Light Jacket", ARMOR),
    ("Metal Coat", ARMOR),
    ("Silver Mail", ARMOR),
    ("Power Jacket", ARMOR),
    ("Quilted Silk", ARMOR),
    ("Metal Armor", ARMOR),
    ("Power Cape", ARMOR),
    ("Magic Bikini", ARMOR),
    ("Silver Robe", ARMOR),
    ("Evening Gown", ARMOR),
    ("Plate Armor", ARMOR),
    ("Plati Plate", ARMOR),
    ("Silk Robe", ARMOR),
    ("Revive Armor", ARMOR),
    ("Crystal Mail", ARMOR),
    ("Crystal Robe", ARMOR),
    ("Heal Armor", ARMOR | VALUABLE),
    ("Metal Jacket", ARMOR),
    ("Deadly Armor (C)", ARMOR),
    ("Deadly Armor", ARMOR),
    ("Eron Dress", ARMOR),
    ("Bright Armor", ARMOR | VALUABLE),
    ("Bright Cloth", ARMOR),
    ("Power Robe", ARMOR),
    ("Magic Scale", ARMOR),
    ("Holy Robe", ARMOR),
    ("Ghostclothes", ARMOR),
    ("Royal Dress", ARMOR),
    ("Full Mail", ARMOR),
    ("Old Armor", ARMOR | VALUABLE),
    ("Zircon Plate", ARMOR),
    ("Zircon Armor", ARMOR),
    ("Mirak Plate", ARMOR | BLUE_CHEST),
    ("Ruse Armor", ARMOR | BLUE_CHEST),
    ("Pearl Armor", ARMOR),
    ("Chop Board", SHIELD),
    ("Small Shield", SHIELD),
    ("Hide Shield", ARMOR),
    ("Buckler", SHIELD),
    ("Mini Shield", SHIELD),
    ("Wood Shield", SHIELD),
    ("Bracelet", SHIELD),
    ("Power Brace", SHIELD),
    ("Kite Shield", SHIELD),
    ("Tough Gloves", SHIELD),
    ("Brone Shield", SHIELD),
    ("Anger Brace", SHIELD),
    ("Block Shield", SHIELD),
    ("Tecto Gloves", SHIELD),
    ("Round Shield", SHIELD),
    ("Pearl Brace", SHIELD),
    ("Fayza Shield", SHIELD),
    ("Big Shield", SHIELD),
    ("Tall Shield", SHIELD),
    ("Silvo Shield", SHIELD),
    ("Spike Shield", SHIELD),
    ("Slash Shield", SHIELD),
    ("Mage Shield", SHIELD),
    ("Tuff Buckler", SHIELD),
    ("Tect Buckler", SHIELD),
    ("Gold Gloves", SHIELD),
    ("Gold Shield", SHIELD),
    ("Plati Gloves", SHIELD),
    ("Plati Shield", SHIELD),
    ("Gauntlet", SHIELD),
    ("Rune Gloves", SHIELD),
    ("Holy Shield", SHIELD),
    ("Zirco Gloves", SHIELD),
    ("Zirco Shield", SHIELD),
    ("Ancient (Old) Shield", SHIELD | VALUABLE),
    ("Flame Shield", SHIELD | BLUE_CHEST),
    ("Water Gaunt", SHIELD | BLUE_CHEST),
    ("Bolt Shield", SHIELD | BLUE_CHEST),
    ("Cryst Shield", SHIELD | BLUE_CHEST),
    ("Mega Shield", SHIELD),
    ("Dark Mirror (C)", SHIELD | BLUE_CHEST),
    ("Dark Mirror", SHIELD | BLUE_CHEST),
    ("Apron Shield", SHIELD | BLUE_CHEST),
    ("Pearl (Divine) Shield", SHIELD),
    ("Pot", HELMET),
    ("Beret", HELMET),
    ("Cap", HELMET),
    ("Cloth Helmet", HELMET),
    ("Hairband", HELMET),
    ("Headband", HELMET),
    ("Hide Helmet", HELMET),
    ("Jet Helm", HELMET),
    ("Red Beret", HELMET),
    ("Glass Cap", HELMET),
    ("Wood Helmet", HELMET),
    ("Blue Beret", HELMET),
    ("Brone Helmet", HELMET),
    ("Stone Helmet", HELMET),
    ("Cloche", HELMET),
    ("Fury Helmet", HELMET),
    ("Iron Helmet", HELMET),
    ("Tight Helmet", HELMET),
    ("Turban", HELMET),
    ("Plate Cap", HELMET),
    ("Roomy Helmet", HELMET),
    ("Tight Turban", HELMET),
    ("Glass Cloche", HELMET),
    ("Plate Helmet", HELMET),
    ("Rock Helmet", HELMET),
    ("Jute Helmet", HELMET),
    ("Shade Hat", HELMET),
    ("Metal Cloche", HELMET),
    ("Silver Helmet", HELMET),
    ("Fury Ribbon", HELMET),
    ("Silver Hat", HELMET),
    ("Eron Hat", HELMET),
    ("Circlet", HELMET),
    ("Golden Helm", HELMET),
    ("Gold Band", HELMET),
    ("Plati Band", HELMET),
    ("Plati Helm", HELMET),
    ("Crysto Beret", HELMET),
    ("Crysto Helm", HELMET),
    ("Holy Cap", HELMET),
    ("Safety Hat", HELMET),
    ("Zirco Band", HELMET),
    ("Zirco Helm", HELMET),
    ("Ancient (Old) Helmet", HELMET | SPECIAL),
    ("Agony Helm", HELMET | BLUE_CHEST),
    ("Boom Turban", HELMET | BLUE_CHEST),
    ("Aqua Helm", HELMET | BLUE_CHEST),
    ("Ice Hairband", HELMET | BLUE_CHEST),
    ("Legend Helm", HELMET),
    ("Hairpin", HELMET | BLUE_CHEST),
    ("Brill Helm", HELMET),
    ("Pearl (Divine) Helmet", HELMET),
    ("Ear Jewel", RING),
    ("Glass Brace", RING),
    ("Glass Ring", RING),
    ("Earring", RING | BLUE_CHEST),
    ("Speedy Ring", RING),
    ("Power Ring", RING),
    ("Muscle Ring", RING),
    ("Protect Ring", RING),
    ("Mind Ring", RING),
    ("Witch Ring", RING),
    ("Fire Ring", RING),
    ("Water Ring", RING),
    ("Ice Ring", RING),
    ("Thunder Ring", RING),
    ("Fury Ring", RING),
    ("Mystery Ring", RING),
    ("Sonic Ring", RING),
    ("Hipower Ring", RING),
    ("Trick Ring", RING),
    ("Fake Ring", RING),
    ("S-Fire Ring", RING),
    ("S-Water Ring", RING),
    ("S-Ice Ring", RING),
    ("S-Thun Ring", RING),
    ("S-Power Ring", RING),
    ("S-Mind Ring", RING),
    ("S-Pro Ring", RING),
    ("S-Witch Ring", RING),
    ("Undead Ring", RING | VALUABLE),
    ("Rocket Ring", RING),
    ("Ghost Ring", RING),
    ("Angry Ring", RING),
    ("S-Myst Ring", RING),
    ("Dia Ring", RING | BLUE_CHEST),
    ("Sea Ring", RING | BLUE_CHEST),
    ("Dragon Ring", RING),
    ("Engage Ring", RING | BLUE_CHEST),
    ("Egg Ring", RING),
    ("Horse Rock", GEM),
    ("Eagle Rock", GEM),
    ("Lion Fang", GEM),
    ("Bee Rock", GEM),
    ("Snake Rock", GEM),
    ("Cancer Rock", GEM),
    ("Pumpkin Jewel", GEM),
    ("Uni Jewel", GEM),
    ("Mysto Jewel", GEM),
    ("Samu Jewel", GEM),
    ("Bat Rock", GEM),
    ("Hidora Rock", GEM),
    ("Flame Jewel", GEM),
    ("Water Jewel", GEM | BLUE_CHEST),
    ("Thundo Jewel", GEM | BLUE_CHEST),
    ("Earth Jewel", GEM | BLUE_CHEST),
    ("Twist Jewel", GEM | BLUE_CHEST),
    ("Gloom Jewel", GEM | BLUE_CHEST),
    ("Tidal Jewel", GEM | BLUE_CHEST),
    ("Magma Rock", GEM),
    ("Evil Jewel (C)", GEM),
    ("Evil Jewel", GEM),
    ("GorgOn Rock", GEM),
    ("Song Rock", GEM),
    ("Kraken Rock", GEM),
    ("Catfish Jewel", GEM | BLUE_CHEST),
    ("Camu Jewel", GEM | BLUE_CHEST),
    ("Spido Jewel", GEM | BLUE_CHEST),
    ("GorgAn Rock", GEM | BLUE_CHEST),
    ("Light Jewel", GEM),
    ("Black Eye", GEM | BLUE_CHEST),
    ("Silver Eye", GEM | BLUE_CHEST),
    ("Gold Eye", GEM | BLUE_CHEST),
    ("1 Coin", SPECIAL),
    ("10 Coin Set", SPECIAL),
    ("50 Coin Set", SPECIAL),
    ("100 Coin Set", SPECIAL),
    ("Flame Charm", SPECIAL),
    ("Zap Charm", SPECIAL),
    ("Magic Lamp", SPECIAL),
    ("Statue", SPECIAL),
    ("Rage Knife", WEAPON | SPECIAL | VALUABLE),
    ("Fortune Whip", WEAPON | SPECIAL | VALUABLE),
    ("Dragon Blade", WEAPON | SPECIAL | VALUABLE),
    ("Bunny Ring", RING | SPECIAL | VALUABLE),
    ("Bunny Ears", HELMET | SPECIAL | VALUABLE),
    ("Bunnylady", GEM | SPECIAL | VALUABLE),
    ("Bunny Sword", WEAPON | SPECIAL | VALUABLE),
    ("Bunny Suit", ARMOR | SPECIAL | VALUABLE),
    ("Seethru Cape", ARMOR | SPECIAL | VALUABLE),
    ("Seethru Silk", ARMOR | SPECIAL | VALUABLE),
    ("Iris Sword", IRIS | SPECIAL),
    ("Iris Shield", IRIS | SPECIAL),
    ("Iris Helmet", IRIS | SPECIAL),
    ("Iris Armor", IRIS | SPECIAL),
    ("Iris Ring", IRIS | SPECIAL),
    ("Iris Jewel", IRIS | SPECIAL),
    ("Iris Staff", IRIS | SPECIAL),
    ("Iris Pot", IRIS | SPECIAL),
    ("Iris Tiara", IRIS | SPECIAL),
    ("Power Jelly", IRIS | SPECIAL),
    ("Jewel Sonar", SCENARIO | SPECIAL),
    ("Hook", SCENARIO | SPECIAL),
    ("Bomb", SCENARIO | SPECIAL),
    ("Arrow", SCENARIO | SPECIAL),
    ("Fire Arrow", SCENARIO | SPECIAL),
    ("Hammer", SCENARIO | SPECIAL),
    ("Treasure Sword", SCENARIO),
    ("Door Key", SCENARIO),
    ("Shrine Key", SCENARIO),
    ("Sky Key", SCENARIO),
    ("Lake Key", SCENARIO),
    ("Ruby Key", SCENARIO),
    ("Wind Key", SCENARIO),
    ("Cloud Key", SCENARIO),
    ("Light Key", SCENARIO),
    ("Sword Key", SCENARIO),
    ("Tree Key", SCENARIO),
    ("Flower Key", SCENARIO),
    ("Magma Key", SCENARIO),
    ("Heart Key", SCENARIO),
    ("Ghost Key", SCENARIO),
    ("Trial Key", SCENARIO),
    ("Dankirk Key", SCENARIO),
    ("Basement Key", SCENARIO),
    ("Narcysus Key", SCENARIO),
    ("Truth Key", SCENARIO),
    ("Mermaid Jade", SCENARIO),
    ("Engine", SCENARIO),
    ("Ancient Key", SCENARIO),
    ("Pretty Flower", SCENARIO),
    ("Glass Angel", SCENARIO),
    ("VIP Card", SCENARIO),
    ("Key 26", SCENARIO | DUMMY),
    ("Key 27", SCENARIO | DUMMY),
    ("Key 28", SCENARIO | DUMMY),
    ("Key 29", SCENARIO | DUMMY),
    ("Key 30", SCENARIO | DUMMY),
    ("Crown", SCENARIO),
    ("Ruby Apple", SCENARIO),
    ("PURIFIA", SCENARIO | DUMMY),
    ("Tag Ring (C)", SCENARIO | DUMMY),
    ("Tag Ring", SCENARIO | DUMMY),
    ("RAN-RAN Step", SCENARIO | DUMMY),
    ("Tag Candy", SCENARIO | DUMMY),
    ("Last", SPECIAL | DUMMY)
]

ITEMS = [entry[0] for entry in ITEM_TABLE]

NON_DUMMY_ITEMS = [item for item, attrs in ITEM_TABLE if not attrs & DUMMY]

ITEM_FLAGS = [entry[1] for entry in ITEM_TABLE]


def find_items_by_flag(flags: int) -> list[str]:
    return [item for item, attrs in ITEM_TABLE if attrs & flags]


def get_item_flags(item: str):
    return ITEM_FLAGS[ITEMS.index(item)]


SPELL_NAMES = list(map(lambda s: s.strip(), """Flash,Bolt,Thunder,Spark,Fireball,Firebird,Droplet,Vortex,Dragon,Gale,
Blizzard,Ice Valkyrie,Perish,Destroy,Drowsy,Coma,Dread,Deflect,Absorb,Fake,Trick,Confuse,Bravery,Courage,Mirror,Strong,
Stronger,Champion,Poison,Rally,Valor,Fry,Zap,Shield,Waken,Release,Warp,Escape,Reset,Light""".split(",")))

ANY_CASTER = MAXIM | TIA | SELAN | LEXIS | ARTEA

SPELL_USERS = {
    # 'Name': Character flags,
    'Reset': MAXIM,
    'Light': SELAN,
    'Dread': TIA | SELAN | LEXIS | ARTEA,
    'Deflect': ANY_CASTER,
    'Strong': ANY_CASTER,
    'Poison': ANY_CASTER,
    'Spark': TIA | SELAN | LEXIS | ARTEA,
    'Droplet': ANY_CASTER,
    'Drowsy': ANY_CASTER,
    'Flash': ANY_CASTER,
    'Gale': ANY_CASTER,
    'Confuse': ANY_CASTER,
    'Bravery': ANY_CASTER,
    'Release': ANY_CASTER,
    'Escape': TIA | SELAN | ARTEA,
    'Warp': TIA | SELAN | ARTEA,
    'Fireball': TIA | SELAN | LEXIS | ARTEA,
    'Fake': ANY_CASTER,
    'Trick': ANY_CASTER,
    'Vortex': ANY_CASTER,
    'Blizzard': ANY_CASTER,
    'Stronger': ANY_CASTER,
    'Rally': ANY_CASTER,
    'Bolt': ANY_CASTER,
    'Absorb': ANY_CASTER,
    'Perish': ANY_CASTER,
    'Waken': ANY_CASTER,
    'Shield': ANY_CASTER,
    'Courage': ANY_CASTER,
    'Mirror': ANY_CASTER,
    'Coma': ANY_CASTER,
    'Champion': ANY_CASTER,
    'Firebird': TIA | SELAN | LEXIS | ARTEA,
    'Ice Valkyrie': ANY_CASTER,
    'Thunder': ANY_CASTER,
    'Dragon': ANY_CASTER,
    'Valor': ANY_CASTER,
    'Fry': ARTEA,
    'Destroy': MAXIM | SELAN,
    'Zap': ARTEA
}

SPELLS = {name: index for index, name in enumerate(SPELL_NAMES)}

for name in SPELL_NAMES:
    assert name in SPELL_USERS, f"no spell users defined for {name}"
